﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Dynamic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace DeleteRespIssue
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow ()
		{
			InitializeComponent();

			this.DataContext = new ViewModel();
		}

		private void XamDataGrid_FieldLayoutInitialized (Object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
		{
			//var grid = sender as XamDataGrid;
			//if (grid == null || grid.DataSource == null)
			//	return;

			//var first = grid.DataSource.Cast<Object>().FirstOrDefault() as IDictionary<String, Object>;
			//if (first == null)
			//	return;

			//List<String> names = first.Keys.ToList();
			//e.FieldLayout.Fields.Clear();
			//foreach (String name in names)
			//{
			//	Field field = new Field
			//	{
			//		Name = name,
			//		Label = name,
			//		BindingType = BindingType.UseAlternateBinding,
			//		AlternateBinding = new Binding(String.Format("[{0}]", name.Replace("^", "^^").Replace(",", "^,"))) { Mode = BindingMode.TwoWay },
			//		Width = new FieldLength(1, FieldLengthUnitType.Auto),
			//		DataType = typeof(String)
			//	};

			//	field.Settings.CellClickAction = CellClickAction.SelectCell;

			//	e.FieldLayout.Fields.Add(field);
			//}
		}
	}

	public class ViewModel : INotifyPropertyChanged
	{
		public ViewModel ()
		{
			this.RemoveCommand = new BasicCommand(this.Remove);

			this.RespondentData = new ObservableCollection<ExpandoObject>();
			dynamic resp1 = new ExpandoObject().Init(
				"ID".WithValue("Walt"),
				"Gender".WithValue("Male"),
				"Age".WithValue("40"));
			dynamic resp2 = new ExpandoObject().Init(
				"ID".WithValue("Katrina"),
				"Gender".WithValue("Female"),
				"Age".WithValue("37"));
			dynamic resp3 = new ExpandoObject().Init(
				"ID".WithValue("Ethan"),
				"Gender".WithValue("Male"),
				"Age".WithValue("14"));

			this.RespondentData.Add(resp1);
			this.RespondentData.Add(resp2);
			this.RespondentData.Add(resp3);
		}

		public ObservableCollection<ExpandoObject> RespondentData { get; private set; }

		public BasicCommand RemoveCommand { get; private set; }

		private void Remove (Object parameter)
		{
			this.RespondentData.RemoveAt(0);
			this.RaisePropertyChanged("RespondentData");
		}

		#region INotifyPropertyChanged Members
		/// <summary>
		/// Public event to fire when a property changes
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged = null;

		/// <summary>
		/// Raises a property changed event
		/// </summary>
		/// <param name="property">The name of the property.  If not specified, it will take the name of the property it is called from</param>
		public void RaisePropertyChanged ([CallerMemberName] String property = null)
		{
			if (this.PropertyChanged != null)
				this.PropertyChanged(this, new PropertyChangedEventArgs(property));
		}
		#endregion
	}

	public class BasicCommand : ICommand
	{
		#region Members
		private readonly Action<Object> execute = null;
		private readonly Predicate<Object> canexecute = null;
		#endregion

		#region Constructors
		/// <summary>
		/// Constructs a new command with the specified execution action
		/// </summary>
		/// <param name="execute">The action to execute when the command is triggered</param>
		public BasicCommand (Action<Object> execute)
			: this(execute, null)
		{
		}

		/// <summary>
		/// Constructs a new command with the specified execution action and check for whether the action is enabled
		/// </summary>
		/// <param name="execute">The action to execute when the command is triggered</param>
		/// <param name="canexecute">The predicate used to check whether the command is available</param>
		public BasicCommand (Action<Object> execute, Predicate<Object> canexecute)
		{
			if (execute == null)
				throw (new ArgumentNullException("execute"));

			this.execute = execute;
			this.canexecute = canexecute;
		}
		#endregion

		#region ICommand Members
		/// <summary>
		/// Determines whether the command can execute in its current state.
		/// </summary>
		/// <param name="parameter">The object to test</param>
		/// <returns>true if the command can execute; false otherwise</returns>
		public Boolean CanExecute (Object parameter)
		{
			return (this.canexecute == null || this.canexecute(parameter));
		}

		/// <summary>
		/// Called when the command is invoked
		/// </summary>
		/// <param name="parameter">Parameter to the command</param>
		public void Execute (Object parameter)
		{
			this.execute(parameter);
		}

		/// <summary>
		/// Occurs when changes occur that affect whether or not the command should execute
		/// </summary>
		public event EventHandler CanExecuteChanged
		{
			add
			{
				CommandManager.RequerySuggested += value;
			}
			remove
			{
				CommandManager.RequerySuggested -= value;
			}
		}
		#endregion
	}

	public static class Extensions
	{
		public static KeyValuePair<string, object> WithValue (this string key, object value)
		{
			return new KeyValuePair<string, object>(key, value);
		}

		public static ExpandoObject Init (
			this ExpandoObject expando, params KeyValuePair<string, object>[] values)
		{
			foreach (KeyValuePair<string, object> kvp in values)
			{
				((IDictionary<string, Object>) expando)[kvp.Key] = kvp.Value;
			}
			return expando;
		}
	}
}